<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>sdioemb: /home/bfsw/host/releases/sdioemb/sdioemb-15/builds/sdioemb-15/sdio_event_log.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.3.5 -->
<div class="qindex"><a class="qindex" href="index.html">Main&nbsp;Page</a> | <a class="qindex" href="modules.html">Modules</a> | <a class="qindex" href="annotated.html">Data&nbsp;Structures</a> | <a class="qindex" href="files.html">File&nbsp;List</a> | <a class="qindex" href="functions.html">Data&nbsp;Fields</a> | <a class="qindex" href="pages.html">Related&nbsp;Pages</a></div>
<h1>/home/bfsw/host/releases/sdioemb/sdioemb-15/builds/sdioemb-15/sdio_event_log.h</h1><div class="fragment"><pre>00001 <span class="comment">/*</span>
00002 <span class="comment"> * Manage a log of the most recent SDIO events (commands and</span>
00003 <span class="comment"> * interrupts etc.).</span>
00004 <span class="comment"> *</span>
00005 <span class="comment"> * Enable the log by #define'ing SDD_DEBUG_EVENT_LOG_LEN to the</span>
00006 <span class="comment"> * maximum number of events to keep in the log.</span>
00007 <span class="comment"> *</span>
00008 <span class="comment"> * Copyright (C) 2007 Cambridge Silicon Radio Ltd.</span>
00009 <span class="comment"> *</span>
00010 <span class="comment"> * Refer to LICENSE.txt included with this source code for details on</span>
00011 <span class="comment"> * the license terms.</span>
00012 <span class="comment"> */</span>
00013 
00014 <span class="preprocessor">#ifndef _SDIO_EVENT_LOG_H</span>
00015 <span class="preprocessor"></span><span class="preprocessor">#define _SDIO_EVENT_LOG_H</span>
00016 <span class="preprocessor"></span>
00017 <span class="preprocessor">#ifdef __linux</span>
00018 <span class="preprocessor"></span><span class="preprocessor">#  define SDD_DEBUG_HAVE_EVENT_LOG</span>
00019 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
00020 <span class="preprocessor"></span>
00021 <span class="preprocessor">#ifndef SDD_DEBUG_EVENT_LOG_LEN</span>
00022 <span class="preprocessor"></span><span class="preprocessor">#  define SDD_DEBUG_EVENT_LOG_LEN 0</span>
00023 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
00024 <span class="preprocessor"></span>
00025 <span class="preprocessor">#ifndef SDD_DEBUG_DATA_BUFFER_LEN</span>
00026 <span class="preprocessor"></span><span class="preprocessor">#  define SDD_DEBUG_DATA_BUFFER_LEN 0</span>
00027 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
00028 <span class="preprocessor"></span>
00029 <span class="preprocessor">#if SDD_DEBUG_EVENT_LOG_LEN &gt; 0 &amp;&amp; defined(SDD_DEBUG_HAVE_EVENT_LOG)</span>
00030 <span class="preprocessor"></span>
00031 <span class="preprocessor">#define SDD_DEBUG_EVENT_LOG</span>
00032 <span class="preprocessor"></span>
00033 <span class="keyword">enum</span> sdio_event_type {
00034     SDD_EVENT_CMD, SDD_EVENT_CARD_INT,
00035     SDD_EVENT_INT_UNMASKED, SDD_EVENT_INT_MASKED,
00036     SDD_EVENT_POWER_ON, SDD_EVENT_POWER_OFF, SDD_EVENT_RESET,
00037     SDD_EVENT_CLOCK_FREQ,
00038 };
00039 
00040 <span class="keyword">struct </span>sdio_event_entry {
00041     <span class="keywordtype">unsigned</span> seq_num;
00042     <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> time_ms;
00043     <span class="keyword">enum</span> sdio_event_type type;
00044     <span class="keyword">union </span>{
00045         <span class="keyword">struct </span>{
00046             <span class="keywordtype">unsigned</span> flags;
00047             <span class="keyword">union </span>{
00048                 <span class="keyword">struct </span><a class="code" href="structsdio__cmd__resp.html">sdio_cmd_resp</a> sdio;
00049                 <span class="keyword">struct </span><a class="code" href="structcspi__cmd__resp.html">cspi_cmd_resp</a> cspi;
00050             };
00051             <span class="keywordtype">int</span> status;
00052 <span class="preprocessor">#if SDD_DEBUG_DATA_BUFFER_LEN &gt; 0</span>
00053 <span class="preprocessor"></span>            <span class="keyword">struct </span>{
00054                 <span class="keywordtype">unsigned</span> length;
00055                 <span class="keywordtype">unsigned</span> start;
00056                 uint8_t *buffer;
00057                 <span class="keyword">struct </span>sdio_event_entry *next;
00058             } data;
00059 <span class="preprocessor">#endif</span>
00060 <span class="preprocessor"></span>        } cmd;
00061         <span class="keywordtype">unsigned</span> functions; <span class="comment">/*&lt; bit mask of relevant functions */</span>
00062         <span class="keywordtype">int</span> val;
00063     };
00064 };
00065 
00066 <span class="comment">/* A ring buffer of SDIO events. */</span>
00067 <span class="keyword">struct </span>sdio_event_log {
00068     <span class="keyword">struct </span>sdio_event_entry *entries;
00069     <span class="keywordtype">unsigned</span> head;
00070     <span class="keywordtype">unsigned</span> tail;
00071     <span class="keywordtype">unsigned</span> seq_num;
00072     os_spinlock_t lock;
00073 
00074 <span class="preprocessor">#if SDD_DEBUG_DATA_BUFFER_LEN &gt; 0</span>
00075 <span class="preprocessor"></span>    <span class="comment">/*</span>
00076 <span class="comment">     * So that we don't display old data but can limit ourselves to</span>
00077 <span class="comment">     * the last n octets of interesting data I play some clever tricks</span>
00078 <span class="comment">     * here.  I store the sdio_cmd_event's that refer to data in a</span>
00079 <span class="comment">     * linked list and also store the length of data blocks in this</span>
00080 <span class="comment">     * list.  When I add a new block to the tail of this list that</span>
00081 <span class="comment">     * increases the data size past the size of sdio_data_buffer I</span>
00082 <span class="comment">     * chop things off the head of the list until the size is OK</span>
00083 <span class="comment">     * again.</span>
00084 <span class="comment">     */</span>
00085     uint8_t *data_buffer;
00086     <span class="keywordtype">unsigned</span> data_start;
00087     <span class="keywordtype">unsigned</span> data_total;
00088     <span class="keyword">struct </span>sdio_event_entry *data_head;
00089     <span class="keyword">struct </span>sdio_event_entry *data_tail;
00090 <span class="preprocessor">#endif</span>
00091 <span class="preprocessor"></span>};
00092 
00093 <span class="keywordtype">void</span> sdio_event_log_init(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00094 <span class="keywordtype">void</span> sdio_event_log_deinit(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00095 <span class="keywordtype">void</span> sdio_event_log(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot, <span class="keyword">enum</span> sdio_event_type type, ...);
00096 <span class="keywordtype">void</span> sdio_event_log_set_response(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot, <span class="keyword">const</span> <span class="keyword">struct</span> <a class="code" href="structsdio__cmd.html">sdio_cmd</a> *cmd);
00097 
00098 <span class="keyword">struct </span>sdio_event_entry *sdio_event_log_get_entry(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot, <span class="keywordtype">unsigned</span> n);
00099 uint8_t sdio_event_log_get_data(<span class="keyword">struct</span> sdio_event_entry *e, <span class="keywordtype">unsigned</span> i);
00100 
00101 <span class="keywordtype">void</span> sdio_os_event_log_init(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00102 <span class="keywordtype">void</span> sdio_os_event_log_deinit(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00103 
00104 <span class="preprocessor">#else</span>
00105 <span class="preprocessor"></span>
00106 <span class="preprocessor">#undef SDD_DEBUG_EVENT_LOG</span>
00107 <span class="preprocessor"></span>
00108 <span class="preprocessor">#define sdio_event_log_init(s)</span>
00109 <span class="preprocessor"></span><span class="preprocessor">#define sdio_event_log_deinit(s)</span>
00110 <span class="preprocessor"></span><span class="preprocessor">#define sdio_event_log(s, t, ...)</span>
00111 <span class="preprocessor"></span><span class="preprocessor">#define sdio_event_log_set_response(s, c)</span>
00112 <span class="preprocessor"></span>
00113 <span class="preprocessor">#endif</span>
00114 <span class="preprocessor"></span>
00115 <span class="preprocessor">#endif </span><span class="comment">/* #ifndef _SDIO_EVENT_LOG_H */</span>
</pre></div><hr size="1"><address style="align: right;"><small>Generated on Fri Nov 21 14:14:54 2008 for sdioemb by
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border=0 > 
</a>1.3.5 </small></address>
</body>
</html>
